﻿using IRaCIS.Application.Contracts;

namespace IRaCIS.Application.Interfaces
{
    public interface IDoctorListQueryService
    {
        /// <summary>
        /// 医生多条件查询
        /// </summary>
        Task<PageOutput<DoctorDTO>> GetDoctorSearchList(DoctorSearchDTO param);

        /// <summary>
        /// 筛选医生列表
        /// </summary>
        /// <param name="doctorSearchModel"></param>
        /// <returns></returns>
        //
        Task<PageOutput<SelectionReviewerDTO>> GetSelectionReviewerList(
           ReviewerSelectionQueryDTO doctorSearchModel);

        /// <summary>
        /// //入组 相关接口   （提交CRO-1）   CRO确认-4 
        /// </summary>
        Task<PageOutput<ConfirmationReviewerDTO>> GetSubmissionOrApprovalReviewerList(
           ReviewerSubmissionQueryDTO doctorIntoGroupSearchModel);


        //医生确认状态列表
        Task<PageOutput<ConfirmationReviewerDTO>> GetConfirmationReviewerList(
           ReviewerConfirmationQueryDTO trialIdPageModel);
    }
}
