namespace IRaCIS.Core.Domain.Models;

[Comment("项目阅片 - 一致性分析生成任务配置")]
[Table("TaskConsistentRule")]
public class TaskConsistentRule : BaseFullAuditEntity
{

    #region 导航属性
    [JsonIgnore]
    public Trial Trial { get; set; }

    [JsonIgnore]
    [ForeignKey("TrialReadingCriterionId")]
    public ReadingQuestionCriterionTrial TrialReadingCriterion { get; set; }
    #endregion

    public Guid TrialId { get; set; }

    public int PlanSubjectCount { get; set; }

    public int PlanVisitCount { get; set; }

    public int IntervalWeeks { get; set; }

    public bool IsHaveReadingPeriod { get; set; }

    public bool IsGenerateGlobalTask { get; set; }

    public int BlindSubjectNumberOfPlaces { get; set; }

    public string BlindTrialSiteCode { get; set; } = string.Empty;

    public bool IsSelfAnalysis { get; set; }

    public bool IsEnable { get; set; }

    public string Note { get; set; } = string.Empty;
    public Guid TrialReadingCriterionId { get; set; }
}

