namespace IRaCIS.Core.Domain.Models;

[Comment("项目 - 项目文档")]
[Table("TrialDocument")]
public class TrialDocument : BaseFullDeleteAuditEntity
{
    #region 导航属性
    [JsonIgnore]
    public List<TrialDocConfirmedUser> TrialDocConfirmedUserList { get; set; }
    [JsonIgnore]
    public List<TrialDocNeedConfirmedUserType> NeedConfirmedUserTypeList { get; set; }
    [JsonIgnore]
    public Trial Trial { get; set; }

    [JsonIgnore]
    [ForeignKey("FileTypeId")]
    public Dictionary FileType { get; set; }
    #endregion
    [Comment("需要确认的项目用户 通过TrialId 关联 用中间表过滤")]
    public Guid FileTypeId { get; set; }

    public string Name { get; set; } = string.Empty;

    public string Path { get; set; } = string.Empty;

    public Guid TrialId { get; set; }

    public string Description { get; set; } = string.Empty;

    public int SignViewMinimumMinutes { get; set; }
}

