﻿namespace IRaCIS.Core.Domain.Models;

[Comment("项目中心 - 推送序列")]
[Table("SCPSeries")]
public class SCPSeries : BaseFullDeleteAuditEntity, IEntitySeqId
{
    #region 导航属性
    [JsonIgnore]
    [ForeignKey("StudyId")]
    public SCPStudy SCPStudy { get; set; }

    [JsonIgnore]
    public List<SCPInstance> SCPInstanceList { get; set; }
    #endregion
    public Guid SeqId { get; set; }
    public Guid StudyId { get; set; }
    public string StudyInstanceUid { get; set; } = string.Empty;
    public string SeriesInstanceUid { get; set; } = string.Empty;
    public int SeriesNumber { get; set; }
    public DateTime? SeriesTime { get; set; }
    public string Modality { get; set; } = string.Empty;
    public string Description { get; set; } = string.Empty;
    public int InstanceCount { get; set; }
    public string SliceThickness { get; set; } = string.Empty;

    public string ImagePositionPatient { get; set; } = string.Empty;
    public string ImageOrientationPatient { get; set; } = string.Empty;
    public string BodyPartExamined { get; set; } = string.Empty;
    public string SequenceName { get; set; } = string.Empty;
    public string ProtocolName { get; set; } = string.Empty;
    public string ImagerPixelSpacing { get; set; } = string.Empty;

    public string AcquisitionTime { get; set; } = string.Empty;
    public string AcquisitionNumber { get; set; } = string.Empty;
    public string TriggerTime { get; set; } = string.Empty;

    public string BodyPartForEdit { get; set; } = string.Empty;

    [StringLength(1000)]
    public string ImageResizePath { get; set; } = string.Empty;

}
