﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class Question : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AlterColumn<string>(
                name: "Remark",
                table: "ReadingTableQuestionTrial",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                comment: "注释",
                oldClrType: typeof(string),
                oldType: "nvarchar(400)",
                oldMaxLength: 400);

            migrationBuilder.AddColumn<string>(
                name: "ClassifyAlgorithms",
                table: "ReadingTableQuestionTrial",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "",
                comment: "分类算法");

            migrationBuilder.AddColumn<Guid>(
                name: "ClassifyTableQuestionId",
                table: "ReadingTableQuestionTrial",
                type: "uniqueidentifier",
                nullable: true,
                comment: "分类问题表格Id");

            migrationBuilder.AlterColumn<string>(
                name: "Remark",
                table: "ReadingTableQuestionSystem",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                comment: "备注",
                oldClrType: typeof(string),
                oldType: "nvarchar(400)",
                oldMaxLength: 400);

            migrationBuilder.AddColumn<bool>(
                name: "IsCopy",
                table: "ReadingTableQuestionSystem",
                type: "bit",
                nullable: false,
                defaultValue: false,
                comment: "复制病灶的时候 是否复制这个问题");

            migrationBuilder.AddColumn<int>(
                name: "ExportIdentification",
                table: "ReadingQuestionTrial",
                type: "int",
                nullable: true,
                comment: "导出标识");

            migrationBuilder.AddColumn<int>(
                name: "ExportResult",
                table: "ReadingQuestionTrial",
                type: "int",
                nullable: true,
                comment: "导出结果");

            migrationBuilder.AddColumn<int>(
                name: "ExportIdentification",
                table: "ReadingQuestionSystem",
                type: "int",
                nullable: true,
                comment: "导出标识");

            migrationBuilder.AddColumn<int>(
                name: "ExportResult",
                table: "ReadingQuestionSystem",
                type: "int",
                nullable: true,
                comment: "导出结果");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ClassifyAlgorithms",
                table: "ReadingTableQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ClassifyTableQuestionId",
                table: "ReadingTableQuestionTrial");

            migrationBuilder.DropColumn(
                name: "IsCopy",
                table: "ReadingTableQuestionSystem");

            migrationBuilder.DropColumn(
                name: "ExportIdentification",
                table: "ReadingQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportResult",
                table: "ReadingQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportIdentification",
                table: "ReadingQuestionSystem");

            migrationBuilder.DropColumn(
                name: "ExportResult",
                table: "ReadingQuestionSystem");

            migrationBuilder.AlterColumn<string>(
                name: "Remark",
                table: "ReadingTableQuestionTrial",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                oldClrType: typeof(string),
                oldType: "nvarchar(400)",
                oldMaxLength: 400,
                oldComment: "注释");

            migrationBuilder.AlterColumn<string>(
                name: "Remark",
                table: "ReadingTableQuestionSystem",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                oldClrType: typeof(string),
                oldType: "nvarchar(400)",
                oldMaxLength: 400,
                oldComment: "备注");
        }
    }
}
